/*
 * Note: this file originally auto-generated by mib2c using
 *  : mib2c.iterate.conf 17695 2009-07-21 12:22:18Z dts12 $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "teraStation.h"

#include<sys/param.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<unistd.h>
#include<string.h>
#include<time.h>
#include<iconv.h>

//#define	BUFFALO_CONF_BACKUP_DETAIL_INFO

/** Initializes the teraStation module */
char **errormon;
int errormon_num;
char outputLocale[64];

void locale_parse_config(const char *token, char *cptr);

void
init_teraStation(void)
{
    FILE *fp;
    char buff[256], *buffp;

    errormon = NULL;
    errormon_num = 0;
    if ((fp = popen("errormon -l | awk '{print $1}'\n", "r")) != NULL) {
	while (fgets(buff, sizeof(buff), fp) != NULL) {
	    if (errormon_num % 5 == 0) {
		errormon = realloc(errormon, (errormon_num + 5) * sizeof(char*));
	    }

	    buffp = &buff[strlen(buff)];
	    while (buffp != buff && isspace((int)*(buffp-1))) {
		    buffp--;
	    }
	    *buffp = '\0';
	    errormon[errormon_num] = strdup(buff);
	    errormon_num++;
	}
    }
    if (!WIFEXITED(pclose(fp))) {
	errormon = NULL;
    }

    outputLocale[0] = '\0';
    snmpd_register_config_handler("locale", locale_parse_config, NULL,
				  "locale-when-outputting-object");
    /*
     * here we initialize all the tables we're planning on supporting 
     */
    initialize_table_nasBackupTable();
    initialize_table_nasDiskTable();
    initialize_table_nasArrayTable();
    initialize_table_nasErrorTable();
    initialize_table_nasInformationTable();
}

void
locale_parse_config(const char *token, char *cptr)
{
	outputLocale[0] = '\0';
	snprintf(outputLocale, sizeof(outputLocale), "%s", cptr);
}

char*
getValue(char* key, char* buff)
{
    int keylen = strlen(key);
    char* buffp;

    if (strncmp(key, buff, keylen) != 0) {
	return NULL;
    }

    buffp = &buff[keylen];
    while(*buffp == ' ' || *buffp == '\t') {
	buffp++;
    }

    if (*buffp != '=') {
	return NULL;
    }

    buffp++;
    while(*buffp == ' ' || *buffp == '\t') {
	buffp++;
    }

    return buffp;
}

void
convChar(char* src, char* dst, size_t* dstlen, long dstsize)
{
    iconv_t it = iconv_open(outputLocale, "UTF-8");
    size_t inleft = strlen(src), outleft = dstsize;

    if (outputLocale[0] == '\0' || it == (iconv_t)-1) {
	*dstlen = sprintf(dst, "%s", src);
    } else if (iconv(it, &src, &inleft, &dst, &outleft) == -1) {
	dst[0] = '\0';
	*dstlen = 0;
    } else {
	*dstlen = dstsize - outleft;
    }
    
    iconv_close(it);
}

//# Determine the first/last column names

/** Initialize the nasBackupTable table by defining its contents and how it's structured */
struct nasBackupTable_entry *
nasBackupTable_createEntry(long nasBackupIndex, char* nasBackupFile);

void
initialize_table_nasBackupTable(void)
{
    const oid       nasBackupTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 1 };
    const size_t    nasBackupTable_oid_len =
        OID_LENGTH(nasBackupTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;
    long i;

    DEBUGMSGTL(("teraStation:init", "initializing table nasBackupTable\n"));

    reg =
        netsnmp_create_handler_registration("nasBackupTable",
                                            nasBackupTable_handler,
                                            nasBackupTable_oid,
                                            nasBackupTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: nasBackupIndex */
                                     0);
    table_info->min_column = COLUMN_NASBACKUPNAME;
    table_info->max_column = COLUMN_NASBACKUPFOLDER;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = nasBackupTable_get_first_data_point;
    iinfo->get_next_data_point = nasBackupTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */
    for (i = NUM_NASBACKUPTASK; i > 0; i--)
	    nasBackupTable_createEntry(i, FILE_NASBACKUPTASK);
}

    /*
     * Typical data structure for a row entry 
     */
struct nasBackupTable_entry {
    /*
     * Index values 
     */
    long            nasBackupIndex;

    char            nasBackupFile[MAXPATHLEN];

    time_t          nasBackupMtime;
    /*
     * Column values 
     */
#if defined(BUFFALO_CONF_BACKUP_DETAIL_INFO)
    char            nasBackupName[1024];
    size_t          nasBackupName_len;
#endif
    long            nasBackupStatus;
#if defined(BUFFALO_CONF_BACKUP_DETAIL_INFO)
    long            nasBackupTrigger;
    char            nasBackupRunTime[8];
    size_t          nasBackupRunTime_len;
    long            nasBackupRunDOW;
    long            nasBackupRunWeek;
    char            nasBackupFolder[MAXPATHLEN * 2];
    size_t          nasBackupFolder_len;
#endif

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct nasBackupTable_entry *next;
};

struct nasBackupTable_entry *nasBackupTable_head;

void
nasBackupTable_updateEntry(struct nasBackupTable_entry *entry)
{
    FILE *fp;
    char buff[256], *buffp;

    if ((fp = fopen(entry->nasBackupFile, "r")) == NULL) {
	return;
    }

    while(fgets(buff, sizeof(buff), fp) != NULL){
	buffp = &buff[strlen(buff)];
	while (buffp != buff && isspace((int)*(buffp-1))) {
	    buffp--;
	}
	*buffp = '\0';

#if defined(BUFFALO_CONF_BACKUP_DETAIL_INFO)
	if((buffp = getValue(LINE_NASBACKUPNAME, buff)) != NULL) {
	    convChar(buffp, entry->nasBackupName, &entry->nasBackupName_len,
		     sizeof(entry->nasBackupName));
	} else
#endif
	if((buffp = getValue(LINE_NASBACKUPSTATUS, buff)) != NULL) {
	    if (strcmp("ready", buffp) == 0)
		entry->nasBackupStatus = NASBACKUPSTATUS_READY;
	    else if (strcmp("run", buffp) == 0)
		entry->nasBackupStatus = NASBACKUPSTATUS_RUN;
	    else if (strcmp("done", buffp) == 0)
		entry->nasBackupStatus = NASBACKUPSTATUS_DONE;
	    else if (strcmp("err", buffp) == 0)
		entry->nasBackupStatus = NASBACKUPSTATUS_ERROR;
	    else
		entry->nasBackupStatus = NASBACKUPSTATUS_NONE;
	}
#if defined(BUFFALO_CONF_BACKUP_DETAIL_INFO)
	else if((buffp = getValue(LINE_NASBACKUPTRIGGER, buff)) != NULL) {
	    if (strcmp("now", buffp) == 0)
		entry->nasBackupTrigger = NASBACKUPTRIGGER_NOW;
	    else if (strcmp("day", buffp) == 0)
		entry->nasBackupTrigger = NASBACKUPTRIGGER_EVERYDAY;
	    else if (strcmp("week", buffp) == 0)
		entry->nasBackupTrigger = NASBACKUPTRIGGER_EVERYWEEK;
	    else if (strcmp("month", buffp) == 0)
		entry->nasBackupTrigger = NASBACKUPTRIGGER_EVERYMONTH;
	    else
		entry->nasBackupTrigger = 0;
	} else if((buffp = getValue(LINE_NASBACKUPTIME, buff)) != NULL) {
	    entry->nasBackupRunTime_len =
		    sprintf(entry->nasBackupRunTime, "%s", buffp);
	} else if((buffp = getValue(LINE_NASBACKUPDOW, buff)) != NULL) {
	    if (strcmp("Sun", buffp) == 0)
		entry->nasBackupRunDOW = NASBACKUPRUNDOW_SUN;
	    else if (strcmp("Mon", buffp) == 0)
		entry->nasBackupRunDOW = NASBACKUPRUNDOW_MON;
	    else if (strcmp("Tue", buffp) == 0)
		entry->nasBackupRunDOW = NASBACKUPRUNDOW_TUE;
	    else if (strcmp("Wed", buffp) == 0)
		entry->nasBackupRunDOW = NASBACKUPRUNDOW_WED;
	    else if (strcmp("Thu", buffp) == 0)
		entry->nasBackupRunDOW = NASBACKUPRUNDOW_THU;
	    else if (strcmp("Fri", buffp) == 0)
		entry->nasBackupRunDOW = NASBACKUPRUNDOW_FRI;
	    else if (strcmp("Sat", buffp) == 0)
		entry->nasBackupRunDOW = NASBACKUPRUNDOW_SAT;
	    else
		entry->nasBackupRunDOW = 0;
	} else if((buffp = getValue(LINE_NASBACKUPWEEK, buff)) != NULL) {
	    if (strcmp("1", buffp) == 0)
		entry->nasBackupRunWeek = NASBACKUPRUNWEEK_FIRSTWEEK;
	    else if (strcmp("2", buffp) == 0)
		entry->nasBackupRunWeek = NASBACKUPRUNWEEK_SECONDWEEK;
	    else if (strcmp("3", buffp) == 0)
		entry->nasBackupRunWeek = NASBACKUPRUNWEEK_THIRDWEEK;
	    else if (strcmp("4", buffp) == 0)
		entry->nasBackupRunWeek = NASBACKUPRUNWEEK_FOURTHWEEK;
	    else if (strcmp("13", buffp) == 0)
		entry->nasBackupRunWeek = NASBACKUPRUNWEEK_FIRSTANDTHIRD;
	    else if (strcmp("24", buffp) == 0)
		entry->nasBackupRunWeek = NASBACKUPRUNWEEK_SECONDANDFOURTH;
	    else
		entry->nasBackupRunWeek = 0;
	} else if((buffp = getValue(LINE_NASBACKUPFOLDER, buff)) != NULL) {
	    convChar(buffp, entry->nasBackupFolder, &entry->nasBackupFolder_len,
		     sizeof(entry->nasBackupFolder));
	}
#endif
    }
    fclose(fp);
}

/*
 * create a new row in the (unsorted) table 
 */
struct nasBackupTable_entry *
nasBackupTable_createEntry(long nasBackupIndex, char* nasBackupFile)
{
    struct nasBackupTable_entry *entry;
    struct stat st;

    entry = SNMP_MALLOC_TYPEDEF(struct nasBackupTable_entry);
    if (!entry)
        return NULL;

    entry->nasBackupIndex = nasBackupIndex;
    snprintf(entry->nasBackupFile, MAXPATHLEN,
	     "%s%d",
	     nasBackupFile, nasBackupIndex);
    entry->nasBackupMtime = 0;
    entry->next = nasBackupTable_head;
    nasBackupTable_head = entry;
    return entry;
}

/*
 * remove a row from the table 
 */
void
nasBackupTable_removeEntry(struct nasBackupTable_entry *entry)
{
    struct nasBackupTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = nasBackupTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        nasBackupTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}

/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
nasBackupTable_get_first_data_point(void **my_loop_context,
                                    void **my_data_context,
                                    netsnmp_variable_list * put_index_data,
                                    netsnmp_iterator_info *mydata)
{
    *my_loop_context = nasBackupTable_head;
    return nasBackupTable_get_next_data_point(my_loop_context,
                                              my_data_context,
                                              put_index_data, mydata);
}

netsnmp_variable_list *
nasBackupTable_get_next_data_point(void **my_loop_context,
                                   void **my_data_context,
                                   netsnmp_variable_list * put_index_data,
                                   netsnmp_iterator_info *mydata)
{
    struct nasBackupTable_entry *entry =
        (struct nasBackupTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER,
                                   entry->nasBackupIndex);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the nasBackupTable table */
int
nasBackupTable_handler(netsnmp_mib_handler *handler,
                       netsnmp_handler_registration *reginfo,
                       netsnmp_agent_request_info *reqinfo,
                       netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct nasBackupTable_entry *table_entry;
    struct stat st;

    DEBUGMSGTL(("teraStation:handler", "Processing request (%d)\n",
                reqinfo->mode));

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct nasBackupTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

	    if (!table_entry || stat(table_entry->nasBackupFile, &st) != 0) {
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHINSTANCE);
                continue;
	    }

	    if (table_entry->nasBackupMtime != st.st_mtime) {
		nasBackupTable_updateEntry(table_entry);
		table_entry->nasBackupMtime = st.st_mtime;
	    }

	    if (table_entry->nasBackupStatus == NASBACKUPSTATUS_NONE) {
		netsnmp_set_request_error(reqinfo, request,
					  SNMP_NOSUCHINSTANCE);
		continue;
	    }

            switch (table_info->colnum) {
#if defined(BUFFALO_CONF_BACKUP_DETAIL_INFO)
            case COLUMN_NASBACKUPNAME:
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->nasBackupName,
                                         table_entry->nasBackupName_len);
                break;
#endif
            case COLUMN_NASBACKUPSTATUS:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasBackupStatus);
                break;
#if defined(BUFFALO_CONF_BACKUP_DETAIL_INFO)
            case COLUMN_NASBACKUPTRIGGER:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasBackupTrigger);
                break;
            case COLUMN_NASBACKUPRUNTIME:
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         nasBackupRunTime,
                                         table_entry->
                                         nasBackupRunTime_len);
                break;
            case COLUMN_NASBACKUPRUNDOW:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasBackupRunDOW);
                break;
            case COLUMN_NASBACKUPRUNWEEK:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasBackupRunWeek);
                break;
            case COLUMN_NASBACKUPFOLDER:
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         nasBackupFolder,
                                         table_entry->nasBackupFolder_len);
                break;
#endif
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

//# Determine the first/last column names

/** Initialize the nasDiskTable table by defining its contents and how it's structured */
struct nasDiskTable_entry *
nasDiskTable_createEntry(long nasDiskIndex, char* nasDiskDisk);

void
initialize_table_nasDiskTable(void)
{
    const oid       nasDiskTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 2 };
    const size_t    nasDiskTable_oid_len = OID_LENGTH(nasDiskTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;
    long i;

    DEBUGMSGTL(("teraStation:init", "initializing table nasDiskTable\n"));

    reg =
        netsnmp_create_handler_registration("nasDiskTable",
                                            nasDiskTable_handler,
                                            nasDiskTable_oid,
                                            nasDiskTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: nasDiskIndex */
                                     0);
    table_info->min_column = COLUMN_NASDISKSTATUS;
    table_info->max_column = COLUMN_NASDISKUSED;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = nasDiskTable_get_first_data_point;
    iinfo->get_next_data_point = nasDiskTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */

    for (i = NUM_NASDISKINFO; i > 0; i--)
	    nasDiskTable_createEntry(i, LINE_NASDISKDISK);
}

    /*
     * Typical data structure for a row entry 
     */
struct nasDiskTable_entry {
    /*
     * Index values 
     */
    long            nasDiskIndex;

    char            nasDiskName[64];
    time_t          nasLastUpdate;

    /*
     * Column values 
     */
    long            nasDiskStatus;
    long            nasDiskCapacity;
    long            nasDiskUsed;

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct nasDiskTable_entry *next;
};

struct nasDiskTable_entry *nasDiskTable_head;

void
nasDiskTable_updateEntry(struct nasDiskTable_entry *entry)
{
    FILE *fp;
    char buff[256], *buffp;
    unsigned long long capacity;
    time_t tm = time(NULL);

    if (tm - entry->nasLastUpdate <= 1) {
	return;
    }
    entry->nasLastUpdate = tm;

    if ((fp = fopen(FILE_NASDISKINFO, "r")) == NULL) {
       	return;
    }

    entry->nasDiskStatus = -1;
    while (fgets(buff, sizeof(buff), fp) != NULL) {
	buffp = &buff[strlen(buff)];
	while (buffp != buff && isspace((int)*(buffp-1))) {
	    buffp--;
	}
	*buffp = '\0';

	if ((buffp = getValue(entry->nasDiskName, buff)) != NULL) {
	    if (strcmp("normal", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_NORMAL;
	    else if (strcmp("array1", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_ARRAY1;
	    else if (strcmp("array2", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_ARRAY2;
	    else if (strcmp("standby", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_STANDBY;
	    else if (strcmp("degrade", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_DEGRADE;
	    else if (strcmp("remove", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_REMOVE;
	    else if (strcmp("standby_removed", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_STANDBYREMOVED;
	    else if (strcmp("degrade_removed", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_DEGRADEREMOVED;
	    else if (strcmp("remove_removed", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_REMOVEREMOVED;
	    else
		entry->nasDiskStatus = 0;
	}
    }
    fclose(fp);

    if (entry->nasDiskStatus == NASDISKSTATUS_NORMAL) {
        snprintf(buff, sizeof(buff),
	         "blockdev --getsize64 /dev/%s\n",
		 entry->nasDiskName);
	if ((fp = popen(buff, "r")) == NULL)
	    entry->nasDiskCapacity = -1;
	else {
	    fgets(buff, sizeof(buff), fp);
	    if (!WIFEXITED(pclose(fp)))
		entry->nasDiskCapacity = -1;
	    else {
	        capacity = strtoull(buff, &buffp, 10);
		entry->nasDiskCapacity = (long)(capacity / 1000000000);
	    }
	}

	snprintf(buff, sizeof(buff),
		 "df | grep '/mnt/%s' | awk '{print $5}'\n",
		 entry->nasDiskName);
	if ((fp = popen(buff, "r")) == NULL) {
		entry->nasDiskUsed = -1;
	} else {
		if (fgets(buff, sizeof(buff), fp) == NULL | !WIFEXITED(pclose(fp))) {
		    entry->nasDiskCapacity = -1;
		    entry->nasDiskUsed = -1;
		} else
		    entry->nasDiskUsed = strtol(buff, &buffp, 10);
	}
    } else {
	entry->nasDiskCapacity = -1;
	entry->nasDiskUsed = -1;
    }
}
/*
 * create a new row in the (unsorted) table 
 */
struct nasDiskTable_entry *
nasDiskTable_createEntry(long nasDiskIndex, char* nasDiskDisk)
{
    struct nasDiskTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(struct nasDiskTable_entry);
    if (!entry)
        return NULL;

    entry->nasDiskIndex = nasDiskIndex;
    snprintf(entry->nasDiskName, sizeof(entry->nasDiskName),
	     "%s%d",
	     nasDiskDisk, nasDiskIndex);
    entry->nasLastUpdate = 0;
    entry->next = nasDiskTable_head;
    nasDiskTable_head = entry;
    return entry;
}

/*
 * remove a row from the table 
 */
void
nasDiskTable_removeEntry(struct nasDiskTable_entry *entry)
{
    struct nasDiskTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = nasDiskTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        nasDiskTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}


/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
nasDiskTable_get_first_data_point(void **my_loop_context,
                                  void **my_data_context,
                                  netsnmp_variable_list * put_index_data,
                                  netsnmp_iterator_info *mydata)
{
    *my_loop_context = nasDiskTable_head;
    return nasDiskTable_get_next_data_point(my_loop_context,
                                            my_data_context,
                                            put_index_data, mydata);
}

netsnmp_variable_list *
nasDiskTable_get_next_data_point(void **my_loop_context,
                                 void **my_data_context,
                                 netsnmp_variable_list * put_index_data,
                                 netsnmp_iterator_info *mydata)
{
    struct nasDiskTable_entry *entry =
        (struct nasDiskTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER, entry->nasDiskIndex);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the nasDiskTable table */
int
nasDiskTable_handler(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct nasDiskTable_entry *table_entry;

    DEBUGMSGTL(("teraStation:handler", "Processing request (%d)\n",
                reqinfo->mode));

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct nasDiskTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

	    if (!table_entry) {
                netsnmp_set_request_error(reqinfo, request,
					  SNMP_NOSUCHINSTANCE);
		continue;
	    }

	    nasDiskTable_updateEntry(table_entry);
	    
            switch (table_info->colnum) {
            case COLUMN_NASDISKSTATUS:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasDiskStatus);
                break;
            case COLUMN_NASDISKCAPACITY:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasDiskCapacity);
                break;
            case COLUMN_NASDISKUSED:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasDiskUsed);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

//# Determine the first/last column names

/** Initialize the nasArrayTable table by defining its contents and how it's structured */
struct nasArrayTable_entry *
nasArrayTable_createEntry(long nasArrayIndex, char* nasArrayArray);

void
initialize_table_nasArrayTable(void)
{
    const oid       nasArrayTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 3 };
    const size_t    nasArrayTable_oid_len = OID_LENGTH(nasArrayTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;
    long i;

    DEBUGMSGTL(("teraStation:init", "initializing table nasArrayTable\n"));

    reg =
        netsnmp_create_handler_registration("nasArrayTable",
                                            nasArrayTable_handler,
                                            nasArrayTable_oid,
                                            nasArrayTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: nasArrayIndex */
                                     0);
    table_info->min_column = COLUMN_NASARRAYSTATUS;
    table_info->max_column = COLUMN_NASARRAYUSED;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = nasArrayTable_get_first_data_point;
    iinfo->get_next_data_point = nasArrayTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */
    for (i = NUM_NASARRAYINFO; i > 0; i--)
	    nasArrayTable_createEntry(i, LINE_NASARRAYARRAY);
}

    /*
     * Typical data structure for a row entry 
     */
struct nasArrayTable_entry {
    /*
     * Index values 
     */
    long            nasArrayIndex;

    char            nasArrayName[64];
    time_t          nasLastUpdate;

    /*
     * Column values 
     */
    long            nasArrayStatus;
    long            nasArrayCapacity;
    long            nasArrayUsed;

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct nasArrayTable_entry *next;
};

struct nasArrayTable_entry *nasArrayTable_head;

void
nasArrayTable_updateEntry(struct nasArrayTable_entry *entry)
{
    FILE *fp;
    char buff[256], *buffp;
    unsigned long long capacity;
    time_t tm = time(NULL);

    if (tm - entry->nasLastUpdate <= 1) {
	return;
    }
    entry->nasLastUpdate = tm;

    if ((fp = fopen(FILE_NASARRAYINFO, "r")) == NULL) {
       	return;
    }

    entry->nasArrayStatus = -1;
    while (fgets(buff, sizeof(buff), fp) != NULL) {
	buffp = &buff[strlen(buff)];
	while (buffp != buff && isspace((int)*(buffp-1))) {
	    buffp--;
	}
	*buffp = '\0';

	if ((buffp = getValue(entry->nasArrayName, buff)) != NULL) {
	    if (strcmp("off", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_OFF;
	    else if (strcmp("raid0", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_RAID0;
	    else if (strcmp("raid1", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_RAID1;
	    else if (strcmp("raid5", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_RAID5;
	    else if (strcmp("raid6", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_RAID6;
	    else if (strcmp("raid10", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_RAID10;
	    else
		entry->nasArrayStatus = 0;
	}
    }
    fclose(fp);

    if (entry->nasArrayStatus != NASARRAYSTATUS_OFF && entry->nasArrayStatus != 0) {
        snprintf(buff, sizeof(buff),
	         "blockdev --getsize64 /dev/md%d",
		 entry->nasArrayStatus == NASARRAYSTATUS_RAID10 ? 4 :
		 entry->nasArrayIndex + 1);
	if ((fp = popen(buff, "r")) == NULL)
	    entry->nasArrayCapacity = -1;
	else {
	    fgets(buff, sizeof(buff), fp);
	    if (!WIFEXITED(pclose(fp)))
		entry->nasArrayCapacity = -1;
	    else {
	        capacity = strtoull(buff, &buffp, 10);
		entry->nasArrayCapacity = (long)(capacity / 1000000000);
	    }
	}

	snprintf(buff, sizeof(buff),
		 "df | grep '/mnt/%s' | awk '{print $5}'",
		 entry->nasArrayName);
	if ((fp = popen(buff, "r")) == NULL) {
		entry->nasArrayUsed = -1;
	} else {
		if (fgets(buff, sizeof(buff), fp) == NULL | !WIFEXITED(pclose(fp))) {
		    entry->nasArrayCapacity = -1;
		    entry->nasArrayUsed = -1;
		} else
		    entry->nasArrayUsed = strtol(buff, &buffp, 10);
	}
    } else {
	entry->nasArrayCapacity = -1;
	entry->nasArrayUsed = -1;
    }
}
/*
 * create a new row in the (unsorted) table 
 */
struct nasArrayTable_entry *
nasArrayTable_createEntry(long nasArrayIndex, char* nasArrayArray)
{
    struct nasArrayTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(struct nasArrayTable_entry);
    if (!entry)
        return NULL;

    entry->nasArrayIndex = nasArrayIndex;
    snprintf(entry->nasArrayName, sizeof(entry->nasArrayName),
	     "%s%d",
	     nasArrayArray, nasArrayIndex);
    entry->nasLastUpdate = 0;
    entry->next = nasArrayTable_head;
    nasArrayTable_head = entry;
    return entry;
}

/*
 * remove a row from the table 
 */
void
nasArrayTable_removeEntry(struct nasArrayTable_entry *entry)
{
    struct nasArrayTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = nasArrayTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        nasArrayTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}


/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
nasArrayTable_get_first_data_point(void **my_loop_context,
                                   void **my_data_context,
                                   netsnmp_variable_list * put_index_data,
                                   netsnmp_iterator_info *mydata)
{
    *my_loop_context = nasArrayTable_head;
    return nasArrayTable_get_next_data_point(my_loop_context,
                                             my_data_context,
                                             put_index_data, mydata);
}

netsnmp_variable_list *
nasArrayTable_get_next_data_point(void **my_loop_context,
                                  void **my_data_context,
                                  netsnmp_variable_list * put_index_data,
                                  netsnmp_iterator_info *mydata)
{
    struct nasArrayTable_entry *entry =
        (struct nasArrayTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER, entry->nasArrayIndex);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the nasArrayTable table */
int
nasArrayTable_handler(netsnmp_mib_handler *handler,
                      netsnmp_handler_registration *reginfo,
                      netsnmp_agent_request_info *reqinfo,
                      netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct nasArrayTable_entry *table_entry;

    DEBUGMSGTL(("teraStation:handler", "Processing request (%d)\n",
                reqinfo->mode));

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct nasArrayTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

	    if (!table_entry) {
                netsnmp_set_request_error(reqinfo, request,
					  SNMP_NOSUCHINSTANCE);
		continue;
	    }

	    nasArrayTable_updateEntry(table_entry);

            switch (table_info->colnum) {
            case COLUMN_NASARRAYSTATUS:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasArrayStatus);
                break;
            case COLUMN_NASARRAYCAPACITY:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasArrayCapacity);
                break;
            case COLUMN_NASARRAYUSED:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasArrayUsed);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

//# Determine the first/last column names

    /*
     * Typical data structure for a row entry 
     */
struct nasErrorTable_entry {
    /*
     * Index values 
     */
    long            nasErrorIndex;

    /*
     * Column values 
     */
    char            nasErrorMsg[128];
    size_t          nasErrorMsg_len;
    char            nasErrorDate[128];
    size_t          nasErrorDate_len;

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct nasErrorTable_entry *next;
};

struct nasErrorTable_entry *nasErrorTable_head;

/** Initialize the nasErrorTable table by defining its contents and how it's structured */
struct nasErrorTable_entry* nasErrorTable_createEntry(long nasErrorIndex);
void nasErrorTable_updateTable(unsigned int reg, void *clientarg);
int send_nasErrorOccur_trap(struct nasErrorTable_entry*);

void
initialize_table_nasErrorTable(void)
{
    const oid       nasErrorTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 4 };
    const size_t    nasErrorTable_oid_len = OID_LENGTH(nasErrorTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;
    long i;

    DEBUGMSGTL(("teraStation:init", "initializing table nasErrorTable\n"));

    reg =
        netsnmp_create_handler_registration("nasErrorTable",
                                            nasErrorTable_handler,
                                            nasErrorTable_oid,
                                            nasErrorTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: nasErrorIndex */
                                     0);
    table_info->min_column = COLUMN_NASERRORMSG;
    table_info->max_column = COLUMN_NASERRORDATE;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = nasErrorTable_get_first_data_point;
    iinfo->get_next_data_point = nasErrorTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */
    for (i = NUM_NASERRORSTATUS; i > 0; i--)
	    nasErrorTable_createEntry(i);

    nasErrorTable_updateTable(0, (void*)nasErrorTable_head);
    snmp_alarm_register(NASERROR_INTERVAL, SA_REPEAT,
			nasErrorTable_updateTable, nasErrorTable_head);
}

void
nasErrorTable_updateTable(unsigned int reg, void *clientarg)
{
    struct nasErrorTable_entry *head, *entry;
    char buff[NUM_NASERRORSTATUS][256], *buffp, *buffn;
    FILE *fp;
    int i, j;

    head = (struct nasErrorTable_entry*)clientarg;
    entry = head;
    
    snprintf(buff[0], sizeof(buff[0]),
	     "cat /tmp/error_status | tail -n %d\n",
	     NUM_NASERRORSTATUS);
    if ((fp = popen(buff[0], "r")) == NULL) {
	return;
    }
    for (i = 0; i < NUM_NASERRORSTATUS; i++) {
	if (fgets(buff[i], sizeof(buff[i]), fp) == NULL) {
	    for (j = i; j < NUM_NASERRORSTATUS; j++) {
		buff[j][0] = '\0';
	    }
	    break;
	}
    }
    if (!WIFEXITED(pclose(fp))) {
	return;
    }

    for (i = 0; i < NUM_NASERRORSTATUS; i++) {
	// delete space from buff's last
	buffp = &buff[i][strlen(buff[i])];
	while (buffp != buff[i] && isspace((int)*(buffp-1))) {
	    buffp--;
	}
	*buffp = '\0';

	// delete space from buff's first
	buffp = buff[i];
	while (isspace((int)*buffp)) {
	    buffp++;
	}

	buffn = buffp;
	while (!isspace((int)*buffn) && *buffn != '\0') {
	    buffn++;
	}
	if (*buffn != '\0') {
	    *(buffn++) = '\0';
	    while(isspace((int)*buffn)) {
		buffn++;
	    }
	}

	if (*buffp == '\0') {
	    entry->nasErrorMsg[0] = '\0';
	    entry->nasErrorMsg_len = 0;
	    entry->nasErrorDate[0] = '\0';
	    entry->nasErrorDate_len = 0;
	    entry = entry->next;
	    continue;
	}

	for (j = 0; errormon != NULL && j < errormon_num; j++) {
	    long pos = strlen(errormon[j]) - strlen(buffp);

	    if (pos < 0 || strcmp(buffp, &errormon[j][pos]) != 0) {
		continue;
	    }

	    snprintf(entry->nasErrorMsg, sizeof(entry->nasErrorMsg),
		     "%s", errormon[j]);
	    break;
	}
	if (errormon == NULL || j == errormon_num) {
		snprintf(entry->nasErrorMsg, sizeof(entry->nasErrorMsg),
			 "%s", buffp);
	}
	entry->nasErrorMsg_len = strlen(entry->nasErrorMsg);


	snprintf(entry->nasErrorDate, sizeof(entry->nasErrorDate),
		 "%s", buffn);
	entry->nasErrorDate_len = strlen(entry->nasErrorDate);


	if (entry->nasErrorMsg[0] != '\0') {
	    send_nasErrorOccur_trap(entry);
	}

	entry = entry->next;
    }
}

/*
 * create a new row in the (unsorted) table 
 */
struct nasErrorTable_entry *
nasErrorTable_createEntry(long nasErrorIndex)
{
    struct nasErrorTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(struct nasErrorTable_entry);
    if (!entry)
        return NULL;

    entry->nasErrorIndex = nasErrorIndex;
    entry->next = nasErrorTable_head;
    nasErrorTable_head = entry;
    return entry;
}

/*
 * remove a row from the table 
 */
void
nasErrorTable_removeEntry(struct nasErrorTable_entry *entry)
{
    struct nasErrorTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = nasErrorTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        nasErrorTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}


/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
nasErrorTable_get_first_data_point(void **my_loop_context,
                                   void **my_data_context,
                                   netsnmp_variable_list * put_index_data,
                                   netsnmp_iterator_info *mydata)
{
    *my_loop_context = nasErrorTable_head;

    return nasErrorTable_get_next_data_point(my_loop_context,
                                             my_data_context,
                                             put_index_data, mydata);
}

netsnmp_variable_list *
nasErrorTable_get_next_data_point(void **my_loop_context,
                                  void **my_data_context,
                                  netsnmp_variable_list * put_index_data,
                                  netsnmp_iterator_info *mydata)
{
    struct nasErrorTable_entry *entry =
        (struct nasErrorTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER, entry->nasErrorIndex);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the nasErrorTable table */
int
nasErrorTable_handler(netsnmp_mib_handler *handler,
                      netsnmp_handler_registration *reginfo,
                      netsnmp_agent_request_info *reqinfo,
                      netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct nasErrorTable_entry *table_entry;

    DEBUGMSGTL(("teraStation:handler", "Processing request (%d)\n",
                reqinfo->mode));

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct nasErrorTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

	    if (!table_entry || table_entry->nasErrorMsg[0] == '\0') {
                netsnmp_set_request_error(reqinfo, request,
					  SNMP_NOSUCHINSTANCE);
		continue;
	    }

            switch (table_info->colnum) {
            case COLUMN_NASERRORMSG:
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         nasErrorMsg,
                                         table_entry->nasErrorMsg_len);
                break;
            case COLUMN_NASERRORDATE:
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         nasErrorDate,
                                         table_entry->nasErrorDate_len);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

//# Determine the first/last column names

    /*
     * Typical data structure for a row entry 
     */
struct nasInformationTable_entry {
    /*
     * Index values 
     */
    long            nasInformationIndex;

    /*
     * Column values 
     */
    char            nasInformationMsg[128];
    size_t          nasInformationMsg_len;
    char            nasInformationDate[128];
    size_t          nasInformationDate_len;

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct nasInformationTable_entry *next;
};

struct nasInformationTable_entry *nasInformationTable_head;

/** Initialize the nasInformationTable table by defining its contents and how it's structured */
struct nasInformationTable_entry*
nasInformationTable_createEntry(long nasInformationIndex);
void nasInformationTable_updateTable(unsigned int reg, void *clientarg);
int send_nasInformationOccur_trap(struct nasInformationTable_entry*);

void
initialize_table_nasInformationTable(void)
{
    const oid       nasInformationTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 5 };
    const size_t    nasInformationTable_oid_len =
        OID_LENGTH(nasInformationTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;
    long i;

    DEBUGMSGTL(("teraStation:init",
                "initializing table nasInformationTable\n"));

    reg =
        netsnmp_create_handler_registration("nasInformationTable",
                                            nasInformationTable_handler,
                                            nasInformationTable_oid,
                                            nasInformationTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: nasInformationIndex */
                                     0);
    table_info->min_column = COLUMN_NASINFORMATIONMSG;
    table_info->max_column = COLUMN_NASINFORMATIONDATE;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = nasInformationTable_get_first_data_point;
    iinfo->get_next_data_point = nasInformationTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */
    for (i = NUM_NASINFORMATIONSTATUS; i > 0; i--)
	    nasInformationTable_createEntry(i);

    nasInformationTable_updateTable(0, (void*)nasInformationTable_head);
    snmp_alarm_register(NASINFORMATION_INTERVAL, SA_REPEAT,
			nasInformationTable_updateTable,
			nasInformationTable_head);
}

void
nasInformationTable_updateTable(unsigned int reg, void *clientarg)
{
    struct nasInformationTable_entry *head, *entry;
    char buff[NUM_NASINFORMATIONSTATUS][256], *buffp, *buffn;
    FILE *fp;
    int i, j;

    head = (struct nasInformationTable_entry*)clientarg;
    entry = head;
    
    snprintf(buff[0], sizeof(buff[0]),
	     "cat /tmp/info_status | tail -n %d\n",
	     NUM_NASINFORMATIONSTATUS);
    if ((fp = popen(buff[0], "r")) == NULL) {
	return;
    }
    for (i = 0; i < NUM_NASINFORMATIONSTATUS; i++) {
	if (fgets(buff[i], sizeof(buff[i]), fp) == NULL) {
	    for (j = i; j < NUM_NASINFORMATIONSTATUS; j++) {
		buff[j][0] = '\0';
	    }
	    break;
	}
    }
    if (!WIFEXITED(pclose(fp))) {
	return;
    }

    for (i = 0; i < NUM_NASINFORMATIONSTATUS; i++) {
	// delete space from buff's last
	buffp = &buff[i][strlen(buff[i])];
	while (buffp != buff[i] && isspace((int)*(buffp-1))) {
	    buffp--;
	}
	*buffp = '\0';

	// delete space from buff's first
	buffp = buff[i];
	while (isspace((int)*buffp)) {
	    buffp++;
	}

	buffn = buffp;
	while (!isspace((int)*buffn) && *buffn != '\0') {
	    buffn++;
	}
	if (*buffn != '\0') {
	    *(buffn++) = '\0';
	    while(isspace((int)*buffn)) {
		buffn++;
	    }
	}

	if (*buffp == '\0') {
	    entry->nasInformationMsg[0] = '\0';
	    entry->nasInformationMsg_len = 0;
	    entry->nasInformationDate[0] = '\0';
	    entry->nasInformationDate_len = 0;
	    entry = entry->next;
	    continue;
	}

	for (j = 0; errormon != NULL && j < errormon_num; j++) {
	    long pos = strlen(errormon[j]) - strlen(buffp);

	    if (pos < 0 || strcmp(buffp, &errormon[j][pos]) != 0) {
		continue;
	    }

	    snprintf(entry->nasInformationMsg,
		     sizeof(entry->nasInformationMsg),
		     "%s", errormon[j]);
	    break;
	}
	if (errormon == NULL || j == errormon_num) {
		snprintf(entry->nasInformationMsg,
			 sizeof(entry->nasInformationMsg),
			 "%s", buffp);
	}
	entry->nasInformationMsg_len = strlen(entry->nasInformationMsg);


	snprintf(entry->nasInformationDate, sizeof(entry->nasInformationDate),
		 "%s", buffn);
	entry->nasInformationDate_len = strlen(entry->nasInformationDate);


	if (entry->nasInformationMsg[0] != '\0') {
	    send_nasInformationOccur_trap(entry);
	}

	entry = entry->next;
    }
}

/*
 * create a new row in the (unsorted) table 
 */
struct nasInformationTable_entry *
nasInformationTable_createEntry(long nasInformationIndex)
{
    struct nasInformationTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(struct nasInformationTable_entry);
    if (!entry)
        return NULL;

    entry->nasInformationIndex = nasInformationIndex;
    entry->next = nasInformationTable_head;
    nasInformationTable_head = entry;
    return entry;
}

/*
 * remove a row from the table 
 */
void
nasInformationTable_removeEntry(struct nasInformationTable_entry *entry)
{
    struct nasInformationTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = nasInformationTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        nasInformationTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}


/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
nasInformationTable_get_first_data_point(void **my_loop_context,
                                         void **my_data_context,
                                         netsnmp_variable_list *
                                         put_index_data,
                                         netsnmp_iterator_info *mydata)
{
    *my_loop_context = nasInformationTable_head;
    return nasInformationTable_get_next_data_point(my_loop_context,
                                                   my_data_context,
                                                   put_index_data, mydata);
}

netsnmp_variable_list *
nasInformationTable_get_next_data_point(void **my_loop_context,
                                        void **my_data_context,
                                        netsnmp_variable_list *
                                        put_index_data,
                                        netsnmp_iterator_info *mydata)
{
    struct nasInformationTable_entry *entry =
        (struct nasInformationTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER,
                                   entry->nasInformationIndex);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the nasInformationTable table */
int
nasInformationTable_handler(netsnmp_mib_handler *handler,
                            netsnmp_handler_registration *reginfo,
                            netsnmp_agent_request_info *reqinfo,
                            netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct nasInformationTable_entry *table_entry;

    DEBUGMSGTL(("teraStation:handler", "Processing request (%d)\n",
                reqinfo->mode));

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct nasInformationTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

	    if (!table_entry || table_entry->nasInformationMsg[0] == '\0') {
                netsnmp_set_request_error(reqinfo, request,
					  SNMP_NOSUCHINSTANCE);
		continue;
	    }

            switch (table_info->colnum) {
            case COLUMN_NASINFORMATIONMSG:
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         nasInformationMsg,
                                         table_entry->
                                         nasInformationMsg_len);
                break;
            case COLUMN_NASINFORMATIONDATE:
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         nasInformationDate,
                                         table_entry->
                                         nasInformationDate_len);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.notify.conf 17455 2009-04-05 09:53:29Z magfr $
 */
static const oid snmptrap_oid[] = { 1, 3, 6, 1, 6, 3, 1, 1, 4, 1, 0 };

int
send_nasErrorOccur_trap(struct nasErrorTable_entry *entry)
{
    netsnmp_variable_list *var_list = NULL;
    const oid       nasErrorOccur_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 2, 1 };
    const oid       nasErrorMsg_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 4, 1, 2, entry->nasErrorIndex
        };
    const oid       nasErrorDate_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 4, 1, 3, entry->nasErrorIndex
        };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, OID_LENGTH(snmptrap_oid),
                              ASN_OBJECT_ID,
                              nasErrorOccur_oid,
                              sizeof(nasErrorOccur_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              nasErrorMsg_oid, OID_LENGTH(nasErrorMsg_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for nasErrorMsg 
                               */
                              entry->nasErrorMsg, entry->nasErrorMsg_len);
    snmp_varlist_add_variable(&var_list,
                              nasErrorDate_oid,
                              OID_LENGTH(nasErrorDate_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for nasErrorDate 
                               */
                              entry->nasErrorDate, entry->nasErrorDate_len);

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_nasInformationOccur_trap(struct nasInformationTable_entry *entry)
{
    netsnmp_variable_list *var_list = NULL;
    const oid       nasInformationOccur_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 2, 2 };
    const oid       nasInformationMsg_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 5, 1, 2, entry->nasInformationIndex
        };
    const oid       nasInformationDate_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 5, 1, 3, entry->nasInformationIndex
        };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, OID_LENGTH(snmptrap_oid),
                              ASN_OBJECT_ID,
                              nasInformationOccur_oid,
                              sizeof(nasInformationOccur_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              nasInformationMsg_oid,
                              OID_LENGTH(nasInformationMsg_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for nasInformationMsg 
                               */
                              entry->nasInformationMsg, entry->nasInformationMsg_len);
    snmp_varlist_add_variable(&var_list,
                              nasInformationDate_oid,
                              OID_LENGTH(nasInformationDate_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for nasInformationDate 
                               */
                              entry->nasInformationDate, entry->nasInformationDate_len);

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}
